Index: admin/js/codemirror/mode/xml/xml.js
===================================================================
--- admin/js/codemirror/mode/xml/xml.js	(revision 3251)
+++ admin/js/codemirror/mode/xml/xml.js	(revision 3251)
@@ -0,0 +1,394 @@
+// CodeMirror, copyright (c) by Marijn Haverbeke and others
+// Distributed under an MIT license: http://codemirror.net/LICENSE
+
+(function(mod) {
+  if (typeof exports == "object" && typeof module == "object") // CommonJS
+    mod(require("../../lib/codemirror"));
+  else if (typeof define == "function" && define.amd) // AMD
+    define(["../../lib/codemirror"], mod);
+  else // Plain browser env
+    mod(CodeMirror);
+})(function(CodeMirror) {
+"use strict";
+
+var htmlConfig = {
+  autoSelfClosers: {'area': true, 'base': true, 'br': true, 'col': true, 'command': true,
+                    'embed': true, 'frame': true, 'hr': true, 'img': true, 'input': true,
+                    'keygen': true, 'link': true, 'meta': true, 'param': true, 'source': true,
+                    'track': true, 'wbr': true, 'menuitem': true},
+  implicitlyClosed: {'dd': true, 'li': true, 'optgroup': true, 'option': true, 'p': true,
+                     'rp': true, 'rt': true, 'tbody': true, 'td': true, 'tfoot': true,
+                     'th': true, 'tr': true},
+  contextGrabbers: {
+    'dd': {'dd': true, 'dt': true},
+    'dt': {'dd': true, 'dt': true},
+    'li': {'li': true},
+    'option': {'option': true, 'optgroup': true},
+    'optgroup': {'optgroup': true},
+    'p': {'address': true, 'article': true, 'aside': true, 'blockquote': true, 'dir': true,
+          'div': true, 'dl': true, 'fieldset': true, 'footer': true, 'form': true,
+          'h1': true, 'h2': true, 'h3': true, 'h4': true, 'h5': true, 'h6': true,
+          'header': true, 'hgroup': true, 'hr': true, 'menu': true, 'nav': true, 'ol': true,
+          'p': true, 'pre': true, 'section': true, 'table': true, 'ul': true},
+    'rp': {'rp': true, 'rt': true},
+    'rt': {'rp': true, 'rt': true},
+    'tbody': {'tbody': true, 'tfoot': true},
+    'td': {'td': true, 'th': true},
+    'tfoot': {'tbody': true},
+    'th': {'td': true, 'th': true},
+    'thead': {'tbody': true, 'tfoot': true},
+    'tr': {'tr': true}
+  },
+  doNotIndent: {"pre": true},
+  allowUnquoted: true,
+  allowMissing: true,
+  caseFold: true
+}
+
+var xmlConfig = {
+  autoSelfClosers: {},
+  implicitlyClosed: {},
+  contextGrabbers: {},
+  doNotIndent: {},
+  allowUnquoted: false,
+  allowMissing: false,
+  caseFold: false
+}
+
+CodeMirror.defineMode("xml", function(editorConf, config_) {
+  var indentUnit = editorConf.indentUnit
+  var config = {}
+  var defaults = config_.htmlMode ? htmlConfig : xmlConfig
+  for (var prop in defaults) config[prop] = defaults[prop]
+  for (var prop in config_) config[prop] = config_[prop]
+
+  // Return variables for tokenizers
+  var type, setStyle;
+
+  function inText(stream, state) {
+    function chain(parser) {
+      state.tokenize = parser;
+      return parser(stream, state);
+    }
+
+    var ch = stream.next();
+    if (ch == "<") {
+      if (stream.eat("!")) {
+        if (stream.eat("[")) {
+          if (stream.match("CDATA[")) return chain(inBlock("atom", "]]>"));
+          else return null;
+        } else if (stream.match("--")) {
+          return chain(inBlock("comment", "-->"));
+        } else if (stream.match("DOCTYPE", true, true)) {
+          stream.eatWhile(/[\w\._\-]/);
+          return chain(doctype(1));
+        } else {
+          return null;
+        }
+      } else if (stream.eat("?")) {
+        stream.eatWhile(/[\w\._\-]/);
+        state.tokenize = inBlock("meta", "?>");
+        return "meta";
+      } else {
+        type = stream.eat("/") ? "closeTag" : "openTag";
+        state.tokenize = inTag;
+        return "tag bracket";
+      }
+    } else if (ch == "&") {
+      var ok;
+      if (stream.eat("#")) {
+        if (stream.eat("x")) {
+          ok = stream.eatWhile(/[a-fA-F\d]/) && stream.eat(";");
+        } else {
+          ok = stream.eatWhile(/[\d]/) && stream.eat(";");
+        }
+      } else {
+        ok = stream.eatWhile(/[\w\.\-:]/) && stream.eat(";");
+      }
+      return ok ? "atom" : "error";
+    } else {
+      stream.eatWhile(/[^&<]/);
+      return null;
+    }
+  }
+  inText.isInText = true;
+
+  function inTag(stream, state) {
+    var ch = stream.next();
+    if (ch == ">" || (ch == "/" && stream.eat(">"))) {
+      state.tokenize = inText;
+      type = ch == ">" ? "endTag" : "selfcloseTag";
+      return "tag bracket";
+    } else if (ch == "=") {
+      type = "equals";
+      return null;
+    } else if (ch == "<") {
+      state.tokenize = inText;
+      state.state = baseState;
+      state.tagName = state.tagStart = null;
+      var next = state.tokenize(stream, state);
+      return next ? next + " tag error" : "tag error";
+    } else if (/[\'\"]/.test(ch)) {
+      state.tokenize = inAttribute(ch);
+      state.stringStartCol = stream.column();
+      return state.tokenize(stream, state);
+    } else {
+      stream.match(/^[^\s\u00a0=<>\"\']*[^\s\u00a0=<>\"\'\/]/);
+      return "word";
+    }
+  }
+
+  function inAttribute(quote) {
+    var closure = function(stream, state) {
+      while (!stream.eol()) {
+        if (stream.next() == quote) {
+          state.tokenize = inTag;
+          break;
+        }
+      }
+      return "string";
+    };
+    closure.isInAttribute = true;
+    return closure;
+  }
+
+  function inBlock(style, terminator) {
+    return function(stream, state) {
+      while (!stream.eol()) {
+        if (stream.match(terminator)) {
+          state.tokenize = inText;
+          break;
+        }
+        stream.next();
+      }
+      return style;
+    };
+  }
+  function doctype(depth) {
+    return function(stream, state) {
+      var ch;
+      while ((ch = stream.next()) != null) {
+        if (ch == "<") {
+          state.tokenize = doctype(depth + 1);
+          return state.tokenize(stream, state);
+        } else if (ch == ">") {
+          if (depth == 1) {
+            state.tokenize = inText;
+            break;
+          } else {
+            state.tokenize = doctype(depth - 1);
+            return state.tokenize(stream, state);
+          }
+        }
+      }
+      return "meta";
+    };
+  }
+
+  function Context(state, tagName, startOfLine) {
+    this.prev = state.context;
+    this.tagName = tagName;
+    this.indent = state.indented;
+    this.startOfLine = startOfLine;
+    if (config.doNotIndent.hasOwnProperty(tagName) || (state.context && state.context.noIndent))
+      this.noIndent = true;
+  }
+  function popContext(state) {
+    if (state.context) state.context = state.context.prev;
+  }
+  function maybePopContext(state, nextTagName) {
+    var parentTagName;
+    while (true) {
+      if (!state.context) {
+        return;
+      }
+      parentTagName = state.context.tagName;
+      if (!config.contextGrabbers.hasOwnProperty(parentTagName) ||
+          !config.contextGrabbers[parentTagName].hasOwnProperty(nextTagName)) {
+        return;
+      }
+      popContext(state);
+    }
+  }
+
+  function baseState(type, stream, state) {
+    if (type == "openTag") {
+      state.tagStart = stream.column();
+      return tagNameState;
+    } else if (type == "closeTag") {
+      return closeTagNameState;
+    } else {
+      return baseState;
+    }
+  }
+  function tagNameState(type, stream, state) {
+    if (type == "word") {
+      state.tagName = stream.current();
+      setStyle = "tag";
+      return attrState;
+    } else {
+      setStyle = "error";
+      return tagNameState;
+    }
+  }
+  function closeTagNameState(type, stream, state) {
+    if (type == "word") {
+      var tagName = stream.current();
+      if (state.context && state.context.tagName != tagName &&
+          config.implicitlyClosed.hasOwnProperty(state.context.tagName))
+        popContext(state);
+      if ((state.context && state.context.tagName == tagName) || config.matchClosing === false) {
+        setStyle = "tag";
+        return closeState;
+      } else {
+        setStyle = "tag error";
+        return closeStateErr;
+      }
+    } else {
+      setStyle = "error";
+      return closeStateErr;
+    }
+  }
+
+  function closeState(type, _stream, state) {
+    if (type != "endTag") {
+      setStyle = "error";
+      return closeState;
+    }
+    popContext(state);
+    return baseState;
+  }
+  function closeStateErr(type, stream, state) {
+    setStyle = "error";
+    return closeState(type, stream, state);
+  }
+
+  function attrState(type, _stream, state) {
+    if (type == "word") {
+      setStyle = "attribute";
+      return attrEqState;
+    } else if (type == "endTag" || type == "selfcloseTag") {
+      var tagName = state.tagName, tagStart = state.tagStart;
+      state.tagName = state.tagStart = null;
+      if (type == "selfcloseTag" ||
+          config.autoSelfClosers.hasOwnProperty(tagName)) {
+        maybePopContext(state, tagName);
+      } else {
+        maybePopContext(state, tagName);
+        state.context = new Context(state, tagName, tagStart == state.indented);
+      }
+      return baseState;
+    }
+    setStyle = "error";
+    return attrState;
+  }
+  function attrEqState(type, stream, state) {
+    if (type == "equals") return attrValueState;
+    if (!config.allowMissing) setStyle = "error";
+    return attrState(type, stream, state);
+  }
+  function attrValueState(type, stream, state) {
+    if (type == "string") return attrContinuedState;
+    if (type == "word" && config.allowUnquoted) {setStyle = "string"; return attrState;}
+    setStyle = "error";
+    return attrState(type, stream, state);
+  }
+  function attrContinuedState(type, stream, state) {
+    if (type == "string") return attrContinuedState;
+    return attrState(type, stream, state);
+  }
+
+  return {
+    startState: function(baseIndent) {
+      var state = {tokenize: inText,
+                   state: baseState,
+                   indented: baseIndent || 0,
+                   tagName: null, tagStart: null,
+                   context: null}
+      if (baseIndent != null) state.baseIndent = baseIndent
+      return state
+    },
+
+    token: function(stream, state) {
+      if (!state.tagName && stream.sol())
+        state.indented = stream.indentation();
+
+      if (stream.eatSpace()) return null;
+      type = null;
+      var style = state.tokenize(stream, state);
+      if ((style || type) && style != "comment") {
+        setStyle = null;
+        state.state = state.state(type || style, stream, state);
+        if (setStyle)
+          style = setStyle == "error" ? style + " error" : setStyle;
+      }
+      return style;
+    },
+
+    indent: function(state, textAfter, fullLine) {
+      var context = state.context;
+      // Indent multi-line strings (e.g. css).
+      if (state.tokenize.isInAttribute) {
+        if (state.tagStart == state.indented)
+          return state.stringStartCol + 1;
+        else
+          return state.indented + indentUnit;
+      }
+      if (context && context.noIndent) return CodeMirror.Pass;
+      if (state.tokenize != inTag && state.tokenize != inText)
+        return fullLine ? fullLine.match(/^(\s*)/)[0].length : 0;
+      // Indent the starts of attribute names.
+      if (state.tagName) {
+        if (config.multilineTagIndentPastTag !== false)
+          return state.tagStart + state.tagName.length + 2;
+        else
+          return state.tagStart + indentUnit * (config.multilineTagIndentFactor || 1);
+      }
+      if (config.alignCDATA && /<!\[CDATA\[/.test(textAfter)) return 0;
+      var tagAfter = textAfter && /^<(\/)?([\w_:\.-]*)/.exec(textAfter);
+      if (tagAfter && tagAfter[1]) { // Closing tag spotted
+        while (context) {
+          if (context.tagName == tagAfter[2]) {
+            context = context.prev;
+            break;
+          } else if (config.implicitlyClosed.hasOwnProperty(context.tagName)) {
+            context = context.prev;
+          } else {
+            break;
+          }
+        }
+      } else if (tagAfter) { // Opening tag spotted
+        while (context) {
+          var grabbers = config.contextGrabbers[context.tagName];
+          if (grabbers && grabbers.hasOwnProperty(tagAfter[2]))
+            context = context.prev;
+          else
+            break;
+        }
+      }
+      while (context && context.prev && !context.startOfLine)
+        context = context.prev;
+      if (context) return context.indent + indentUnit;
+      else return state.baseIndent || 0;
+    },
+
+    electricInput: /<\/[\s\w:]+>$/,
+    blockCommentStart: "<!--",
+    blockCommentEnd: "-->",
+
+    configuration: config.htmlMode ? "html" : "xml",
+    helperType: config.htmlMode ? "html" : "xml",
+
+    skipAttribute: function(state) {
+      if (state.state == attrValueState)
+        state.state = attrState
+    }
+  };
+});
+
+CodeMirror.defineMIME("text/xml", "xml");
+CodeMirror.defineMIME("application/xml", "xml");
+if (!CodeMirror.mimeModes.hasOwnProperty("text/html"))
+  CodeMirror.defineMIME("text/html", {name: "xml", htmlMode: true});
+
+});
Index: admin/media.php
===================================================================
--- admin/media.php	(revision 3212)
+++ admin/media.php	(revision 3245)
@@ -142,8 +142,34 @@
 }
 
+# Cope with fav/unfav dir
+$fav_dirs = null;
+if (!empty($_GET['fav'])) {
+	if (!$q) { // Ignore search results
+		$fav_dir = rtrim($d,'/');
+		$core->auth->user_prefs->addWorkspace('interface');
+		$nb_last_dirs = (integer)($core->auth->user_prefs->interface->media_nb_last_dirs);
+		if ($nb_last_dirs > 0) {
+			$fav_dirs = $core->auth->user_prefs->interface->media_fav_dirs;
+			if (!is_array($fav_dirs)) {
+				$fav_dirs = array();
+			}
+			if (!in_array($fav_dir,$fav_dirs) && $_GET['fav'] == 'y') {
+				// Add directory in favorites
+				array_unshift($fav_dirs,$fav_dir);
+			} elseif (in_array($fav_dir,$fav_dirs) && $_GET['fav'] == 'n') {
+				// Remove directory from favorites
+				unset($fav_dirs[array_search($fav_dir,$fav_dirs)]);
+			}
+			// Store new list
+			$core->auth->user_prefs->interface->put('media_fav_dirs',$fav_dirs,'array');
+			$core->adminurl->redirect('admin.media',$page_url_params);
+		}
+	}
+}
+
 # Recent media dirs
 $last_dirs = null;
 if (!$q) {	// Ignore search results
-	$recent_dir = rtrim($d,'/');;
+	$recent_dir = rtrim($d,'/');
 	$core->auth->user_prefs->addWorkspace('interface');
 	$nb_last_dirs = (integer)($core->auth->user_prefs->interface->media_nb_last_dirs);
@@ -404,6 +430,37 @@
 $last_folders = '';
 $last_folders_item = '';
+$fav_url = '';
+$fav_img = '';
+$fav_alt = '';
 $nb_last_dirs = (integer)($core->auth->user_prefs->interface->media_nb_last_dirs);
 if ($nb_last_dirs > 0) {
+	// Favorites directories
+	$fav_dirs = $core->auth->user_prefs->interface->media_fav_dirs;
+	if (!is_array($fav_dirs)) {
+		$fav_dirs = array();
+	}
+	foreach ($fav_dirs as $ld) {
+		// Add favorites dirs on top of combo
+		$ld_params = $page_url_params;
+		$ld_params['d'] = $ld;
+		$ld_params['q'] = '';	// Reset search
+		$last_folders_item .=
+			'<option value="'.urldecode($core->adminurl->get('admin.media',$ld_params)).'"'.
+			($ld == rtrim($d,'/') ? ' selected="selected"' : '').'>'.
+			'/'.$ld.'</option>'."\n";
+		if ($ld == rtrim($d,'/')) {
+			// Current directory is a favorite → button will un-fav
+			$ld_params['fav'] = 'n';
+			$fav_url = urldecode($core->adminurl->get('admin.media',$ld_params));
+			unset($ld_params['fav']);
+			$fav_img = 'images/fav-on.png';
+			$fav_alt = __('Remove this folder from your favorites');
+		}
+	}
+	if ($last_folders_item != '') {
+		// add a separator between favorite dirs and recent dirs
+		$last_folders_item .= '<option disabled>_________</option>';
+	}
+	// Recent directories
 	if (!is_array($last_dirs)) {
 		$last_dirs = $core->auth->user_prefs->interface->media_last_dirs;
@@ -411,24 +468,35 @@
 	if (is_array($last_dirs)) {
 		foreach ($last_dirs as $ld) {
-			$ld_params = $page_url_params;
-			$ld_params['d'] = $ld;
-			$ld_params['q'] = '';	// Reset search
-			$last_folders_item .=
-				'<option value="'.urldecode($core->adminurl->get('admin.media',$ld_params)).'"'.
-				($ld == rtrim($d,'/') ? ' selected="selected"' : '').'>'.
-				'/'.$ld.'</option>'."\n";
-		}
-		if ($last_folders_item != '') {
-			$last_folders =
-				'<p class="media-recent hidden-if-no-js">'.
-				'<label class="classic" for="switchfolder">'.__('Goto recent folder:').'</label> '.
-				'<select name="switchfolder" id="switchfolder">'.
-				$last_folders_item.
-				'</select>'.
-				'<script type="text/javascript">var urlmenu = document.getElementById(\'switchfolder\');
-				 urlmenu.onchange = function() { window.location = this.options[this.selectedIndex].value; };
-				</script>'.
-				'</p>';
-		}
+			if (!in_array($ld,$fav_dirs)) {
+				$ld_params = $page_url_params;
+				$ld_params['d'] = $ld;
+				$ld_params['q'] = '';	// Reset search
+				$last_folders_item .=
+					'<option value="'.urldecode($core->adminurl->get('admin.media',$ld_params)).'"'.
+					($ld == rtrim($d,'/') ? ' selected="selected"' : '').'>'.
+					'/'.$ld.'</option>'."\n";
+				if ($ld == rtrim($d,'/')) {
+					// Current directory is not a favorite → button will fav
+					$ld_params['fav'] = 'y';
+					$fav_url = urldecode($core->adminurl->get('admin.media',$ld_params));
+					unset($ld_params['fav']);
+					$fav_img = 'images/fav-off.png';
+					$fav_alt = __('Add this folder to your favorites');
+				}
+			}
+		}
+	}
+	if ($last_folders_item != '') {
+		$last_folders =
+			'<p class="media-recent hidden-if-no-js">'.
+			'<label class="classic" for="switchfolder">'.__('Goto recent folder:').'</label> '.
+			'<select name="switchfolder" id="switchfolder">'.
+			$last_folders_item.
+			'</select>'.
+			'<script type="text/javascript">var urlmenu = document.getElementById(\'switchfolder\');
+			 urlmenu.onchange = function() { window.location = this.options[this.selectedIndex].value; };
+			</script>'.
+			' <a id="media-fav-dir" href="'.$fav_url.'" title="'.$fav_alt.'"><img src="'.$fav_img.'" alt="'.$fav_alt.'" /></a>'.
+			'</p>';
 	}
 }
Index: admin/post.php
===================================================================
--- admin/post.php	(revision 3024)
+++ admin/post.php	(revision 3209)
@@ -52,5 +52,5 @@
 # Getting categories
 $categories_combo = dcAdminCombos::getCategoriesCombo(
-	$core->blog->getCategories(array('post_type'=>'post'))
+	$core->blog->getCategories()
 );
 
@@ -335,5 +335,5 @@
 # Getting categories
 $categories_combo = dcAdminCombos::getCategoriesCombo(
-	$core->blog->getCategories(array('post_type'=>'post'))
+	$core->blog->getCategories()
 );
 /* DISPLAY
Index: admin/posts.php
===================================================================
--- admin/posts.php	(revision 3182)
+++ admin/posts.php	(revision 3209)
@@ -17,5 +17,5 @@
 # Getting categories
 try {
-	$categories = $core->blog->getCategories(array('post_type'=>'post'));
+	$categories = $core->blog->getCategories();
 } catch (Exception $e) {
 	$core->error->add($e->getMessage());
Index: admin/preferences.php
===================================================================
--- admin/preferences.php	(revision 3198)
+++ admin/preferences.php	(revision 3245)
@@ -35,4 +35,5 @@
 $user_dm_dcnews = $core->auth->user_prefs->dashboard->dcnews;
 $user_dm_quickentry = $core->auth->user_prefs->dashboard->quickentry;
+$user_dm_nofavicons = $core->auth->user_prefs->dashboard->nofavicons;
 
 $core->auth->user_prefs->addWorkspace('accessibility');
@@ -194,4 +195,5 @@
 		$core->auth->user_prefs->interface->put('media_nb_last_dirs',(integer)$_POST['user_ui_media_nb_last_dirs'],'integer');
 		$core->auth->user_prefs->interface->put('media_last_dirs',array(),'array',null,false);
+		$core->auth->user_prefs->interface->put('media_fav_dirs',array(),'array',null,false);
 
 		# Update user
@@ -221,4 +223,5 @@
 		$core->auth->user_prefs->dashboard->put('dcnews',!empty($_POST['user_dm_dcnews']),'boolean');
 		$core->auth->user_prefs->dashboard->put('quickentry',!empty($_POST['user_dm_quickentry']),'boolean');
+		$core->auth->user_prefs->dashboard->put('nofavicons',empty($_POST['user_dm_nofavicons']),'boolean');
 		$core->auth->user_prefs->interface->put('iconset',(!empty($_POST['user_ui_iconset']) ? $_POST['user_ui_iconset'] : ''));
 		$core->auth->user_prefs->interface->put('nofavmenu',empty($_POST['user_ui_nofavmenu']),'boolean');
@@ -611,14 +614,20 @@
 __('Display favorites at the top of the menu').'</label></p></div>';
 
+echo
+'<div class="fieldset">'.
+'<h4>'.__('Dashboard icons').'</h4>'.
+'<p><label for="user_dm_nofavicons" class="classic">'.
+form::checkbox('user_dm_nofavicons',1,!$user_dm_nofavicons).' '.
+__('Display dashboard icons').'</label></p>';
+
 if (count($iconsets_combo) > 1) {
 	echo
-		'<div class="fieldset">'.
-		'<h4>'.__('Dashboard icons').'</h4>'.
 		'<p><label for="user_ui_iconset" class="classic">'.__('Iconset:').'</label> '.
-		form::combo('user_ui_iconset',$iconsets_combo,$user_ui_iconset).'</p>'.
-		'</div>';
+		form::combo('user_ui_iconset',$iconsets_combo,$user_ui_iconset).'</p>';
 } else {
 	echo '<p class="hidden">'.form::hidden('user_ui_iconset','').'</p>';
 }
+echo
+'</div>';
 
 echo
Index: inc/admin/lib.dc.page.php
===================================================================
--- inc/admin/lib.dc.page.php	(revision 3178)
+++ inc/admin/lib.dc.page.php	(revision 3253)
@@ -298,9 +298,8 @@
 
 		$figure = "
-    @..@
-   (----)
-  ( >__< )
-  ^^ ~~ ^^
-		";
+   /\_/\
+  (='.'=)
+  (\")-(\")
+  		";
 
 		echo
@@ -911,5 +910,5 @@
 		"</script>\n".
 
-		self::jsLoad('js/jsUpload/vendor/jquery.ui.widget.js').
+		self::jsLoad('js/jquery/jquery-ui.custom.js').
 		self::jsLoad('js/jsUpload/tmpl.js').
 		self::jsLoad('js/jsUpload/template-upload.js').
@@ -940,4 +939,42 @@
 	}
 
+	public static function jsCodeMirror($theme = '',$multi = true,$modes = array('css','htmlmixed','javascript','php','xml'))
+	{
+		$ret =
+			self::cssLoad('js/codemirror/lib/codemirror.css').
+			self::jsLoad('js/codemirror/lib/codemirror.js');
+		if ($multi) {
+			$ret .= self::jsLoad('js/codemirror/addon/mode/multiplex.js');
+		}
+		foreach ($modes as $mode) {
+			$ret .= self::jsLoad('js/codemirror/mode/'.$mode.'/'.$mode.'.js');
+		}
+		$ret .=
+			self::jsLoad('js/codemirror/addon/edit/closebrackets.js').
+			self::jsLoad('js/codemirror/addon/edit/matchbrackets.js').
+			self::cssLoad('js/codemirror/addon/display/fullscreen.css').
+			self::jsLoad('js/codemirror/addon/display/fullscreen.js');
+		if ($theme != '') {
+			$ret .= self::cssLoad('js/codemirror/theme/'.$theme.'.css');
+		}
+		return $ret;
+	}
+
+	public static function getCodeMirrorThemes()
+	{
+		$themes = array();
+		$themes_root = dirname(__FILE__).'/../../admin'.'/js/codemirror/theme/';
+		if (is_dir($themes_root) && is_readable($themes_root)) {
+			if (($d = @dir($themes_root)) !== false) {
+				while (($entry = $d->read()) !== false) {
+					if ($entry != '.' && $entry != '..' && substr($entry, 0, 1) != '.' && is_readable($themes_root.'/'.$entry)) {
+						$themes[] = substr($entry,0,-4); // remove .css extension
+					}
+				}
+			}
+		}
+		return $themes;
+	}
+
 	public static function getPF($file)
 	{
Index: inc/admin/lib.pager.php
===================================================================
--- inc/admin/lib.pager.php	(revision 3118)
+++ inc/admin/lib.pager.php	(revision 3239)
@@ -175,7 +175,31 @@
 
 			if( $filter ) {
-				$html_block .= '<caption>'.sprintf(__('List of %s entries match the filter.'), $this->rs_count).'</caption>';
+				$html_block .= '<caption>'.sprintf(__('List of %s entries matching the filter.'), $this->rs_count).'</caption>';
 			} else {
-				$html_block .= '<caption class="hidden">'.__('Entries list').'</caption>';
+				$nb_published = $this->core->blog->getPosts(array('post_status' => 1),true)->f(0);
+				$nb_pending = $this->core->blog->getPosts(array('post_status' => -2),true)->f(0);
+				$nb_programmed = $this->core->blog->getPosts(array('post_status' => -1),true)->f(0);
+				$nb_unpublished = $this->core->blog->getPosts(array('post_status' => 0),true)->f(0);
+				$html_block .= '<caption>'.
+					sprintf(__('List of entries (%s)'),$this->rs_count).
+					($nb_published ?
+						sprintf(
+						__(', <a href="%s">published</a> (1)',', <a href="%s">published</a> (%s)',$nb_published),
+						$this->core->adminurl->get('admin.posts',array('status' => 1)),
+						$nb_published) : '').
+					($nb_pending ?
+						sprintf(
+						__(', <a href="%s">pending</a> (1)',', <a href="%s">pending</a> (%s)',$nb_pending),
+						$this->core->adminurl->get('admin.posts',array('status' => -2)),
+						$nb_pending) : '').
+					($nb_programmed ?
+						sprintf(__(', <a href="%s">programmed</a> (1)',', <a href="%s">programmed</a> (%s)',$nb_programmed),
+						$this->core->adminurl->get('admin.posts',array('status' => -1)),
+						$nb_programmed) : '').
+					($nb_unpublished ?
+						sprintf(__(', <a href="%s">unpublished</a> (1)',', <a href="%s">unpublished</a> (%s)',$nb_unpublished),
+						$this->core->adminurl->get('admin.posts',array('status' => 0)),
+						$nb_unpublished) : '').
+					'</caption>';
 			}
 
@@ -454,5 +478,29 @@
 					'</caption>';
 			} else {
-				$html_block .= '<caption class="hidden">'.__('Comments and trackbacks list').'</caption>';
+				$nb_published = $this->core->blog->getComments(array('comment_status' => 1),true)->f(0);
+				$nb_spam = $this->core->blog->getComments(array('comment_status' => -2),true)->f(0);
+				$nb_pending = $this->core->blog->getComments(array('comment_status' => -1),true)->f(0);
+				$nb_unpublished = $this->core->blog->getComments(array('comment_status' => 0),true)->f(0);
+				$html_block .= '<caption>'.
+					sprintf(__('List of comments and trackbacks (%s)'),$this->rs_count).
+					($nb_published ?
+						sprintf(
+						__(', <a href="%s">published</a> (1)',', <a href="%s">published</a> (%s)',$nb_published),
+						$this->core->adminurl->get('admin.comments',array('status' => 1)),
+						$nb_published) : '').
+					($nb_spam ?
+						sprintf(
+						__(', <a href="%s">spam</a> (1)',', <a href="%s">spam</a> (%s)',$nb_spam),
+						$this->core->adminurl->get('admin.comments',array('status' => -2)),
+						$nb_spam) : '').
+					($nb_pending ?
+						sprintf(__(', <a href="%s">pending</a> (1)',', <a href="%s">pending</a> (%s)',$nb_pending),
+						$this->core->adminurl->get('admin.comments',array('status' => -1)),
+						$nb_pending) : '').
+					($nb_unpublished ?
+						sprintf(__(', <a href="%s">unpublished</a> (1)',', <a href="%s">unpublished</a> (%s)',$nb_unpublished),
+						$this->core->adminurl->get('admin.comments',array('status' => 0)),
+						$nb_unpublished) : '').
+					'</caption>';
 			}
 
Index: inc/core/class.dc.auth.php
===================================================================
--- inc/core/class.dc.auth.php	(revision 3036)
+++ inc/core/class.dc.auth.php	(revision 3231)
@@ -172,5 +172,5 @@
 	public function crypt($pwd)
 	{
-		return crypt::hmac(DC_MASTER_KEY,$pwd);
+		return crypt::hmac(DC_MASTER_KEY,$pwd,DC_CRYPT_ALGO);
 	}
 
@@ -310,5 +310,5 @@
 
 		$user_id = trim(@pack('a32',substr($code,0,32)));
-		$pwd = @unpack('H40hex',substr($code,32,40));
+		$pwd = @unpack('H*hex',substr($code,32));
 
 		if ($user_id === false || $pwd === false) {
Index: inc/core/class.dc.core.php
===================================================================
--- inc/core/class.dc.core.php	(revision 3216)
+++ inc/core/class.dc.core.php	(revision 3231)
@@ -198,4 +198,5 @@
 	public function checkNonce($secret)
 	{
+		// 40 alphanumeric characters min
 		if (!preg_match('/^([0-9a-f]{40,})$/i',$secret)) {
 			return false;
@@ -1206,4 +1207,5 @@
 			'active_quote' => 1,
 			'active_pre' => 1,
+			'active_aside' => 1,
 			'active_empty' => 1,
 			'active_auto_br' => 0,
@@ -1252,4 +1254,5 @@
 			'active_quote' => 0,
 			'active_pre' => 0,
+			'active_aside' => 0,
 			'active_empty' => 0,
 			'active_auto_br' => 1,
@@ -1292,4 +1295,5 @@
 			'active_quote' => 0,
 			'active_pre' => 1,
+			'active_aside' => 0,
 			'active_empty' => 0,
 			'active_auto_br' => 1,
Index: inc/core/class.dc.namespace.php
===================================================================
--- inc/core/class.dc.namespace.php	(revision 3203)
+++ inc/core/class.dc.namespace.php	(revision 3225)
@@ -391,4 +391,14 @@
 
 	/**
+	Returns $ns property content.
+
+	@return	<b>string</b>
+	*/
+	public function dumpNamespace()
+	{
+		return $this->ns;
+	}
+
+	/**
 	Returns $settings property content.
 
@@ -401,4 +411,14 @@
 
 	/**
+	Returns $local_settings property content.
+
+	@return	<b>array</b>
+	*/
+	public function dumpLocalSettings()
+	{
+		return $this->local_settings;
+	}
+
+	/**
 	Returns $global_settings property content.
 
Index: inc/core/class.dc.workspace.php
===================================================================
--- inc/core/class.dc.workspace.php	(revision 3203)
+++ inc/core/class.dc.workspace.php	(revision 3225)
@@ -407,4 +407,14 @@
 
 	/**
+	Returns $ws property content.
+
+	@return	<b>string</b>
+	*/
+	public function dumpWorkspace()
+	{
+		return $this->ws;
+	}
+
+	/**
 	Returns $prefs property content.
 
